   **********  Accounts COMMAND FILE  **********
* THIS IS THE CONTROL MODULE FOR ALL THE PROCEDURES USED IN THE ACCOUNTING
* SYSTEM.  The menu selection here calls up sub-menus that can call
* other sub-sub-menus.
******************************************************
**
CLEAR ALL
SET TALK OFF
PUBLIC F1,F2,F3,F4,F5,F6,F7,F8,F9,F10
USE Functions
Num = '1'
DO WHILE .NOT. EOF()
        F&Num = TRIM(Fnumber)
        Num = STR(&Num + 1,2)
        IF SPACE(1) $ NUM
            Num = SUBSTR(Num,2,1)
        ENDIF
        SKIP
ENDDO
USE
SET BELL OFF
SET HEADING OFF
SET SAFETY OFF
SET FUNCTION 3 TO 'C'
SET FUNCTION 4 TO 'E'
SET FUNCTION 5 TO 'A'
SET FUNCTION 6 TO 'D'
* 
DO WHILE .T.
   CLEAR
   ? ' * * * * * * * * * * *   M A I N   M E N U   * * * * * * * * * * *'
   ?
   ? '1> ENTER BILLS & TIME SHEETS        5> JOB COSTS FOR BILLING'
   ? 
   ? '2> PAY BILLS & SALARIES             6> RE-INDEX DATA FILES'
   ?
   ? '3> DEPOSITS & CHECKBOOK             7> OUTSTANDING INVOICES'
   ?
   ? '4> CLIENT BILLING'
   ?
   ? ' * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *'
   ?
   ? '            Pick a number or type Q to QUIT'
   ?
   WAIT ' ' TO Choice
   *
   DO CASE
    CASE Choice = '1'
       @ ROW(),0 SAY 'Loading Bills & Time Sheets'
       DO Costmenu
    CASE Choice = '2'
       @ ROW(),0 SAY 'Loading Pay Bills & Salaries'
       DO Paymenu
    CASE Choice = '3'
       @ ROW(),0 SAY 'Loading Deposits & Checkbook'
       DO Depmenu
    CASE Choice = '4'
       @ ROW(),0 SAY 'Loading Client Billing'
       DO Invmenu
    CASE Choice = '5'
       @ ROW(),0 SAY 'Loading Cost For Billing'
       DO Jobcosts
    CASE Choice = '6'
       DO Indexing
    CASE Choice = '7'
       CLEAR
       ? '               OUTSTANDING INVOICES'
       SELECT 8
       USE Invoices INDEX Invoices
       DISPLAY All Inv_Date, Inv_Nmbr, Client, Amount FOR Amt_Rcd = 0
       WAIT
       CLEAR ALL
    CASE UPPER(Choice) = 'Q'
       EXIT
       *
   ENDCASE Choice
ENDDO

SET TALK ON
SET BELL ON
SET HEADING ON
SET SAFETY ON
SET FUNCTION 3 TO 'list;'
SET FUNCTION 4 TO 'dir;'
SET FUNCTION 5 TO 'display structure;'
SET FUNCTION 6 TO 'display status;'
RELEASE ALL
CLEAR
? "Accounts Command File Terminated"
